

#define	VERSJA	"1.0"
#define	TYPE	"SkanerDMX"


/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1
#define	false	FALSE
#define	true	TRUE
#define	False	FALSE
#define	True	TRUE


#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC


#define	CNT0_PRESCALER_0		0
#define	CNT0_PRESCALER_1		1
#define	CNT0_PRESCALER_8		2
#define	CNT0_PRESCALER_64		3
#define	CNT0_PRESCALER_256		4
#define	CNT0_PRESCALER_1024		5
#define	CNT0_PRESCALER_T0faling	6
#define	CNT0_PRESCALER_T0rising	7

#define	CNT1_PRESCALER_0		0
#define	CNT1_PRESCALER_1		1
#define	CNT1_PRESCALER_8		2
#define	CNT1_PRESCALER_64		3
#define	CNT1_PRESCALER_256		4
#define	CNT1_PRESCALER_1024		5
#define	CNT1_PRESCALER_T1faling	6
#define	CNT1_PRESCALER_T1rising	7

#define	CNT2_PRESCALER_0		0
#define	CNT2_PRESCALER_1		1
#define	CNT2_PRESCALER_8		2
#define	CNT2_PRESCALER_32		3
#define	CNT2_PRESCALER_64		4
#define	CNT2_PRESCALER_128		5
#define	CNT2_PRESCALER_256		6
#define	CNT2_PRESCALER_1024		7



#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define	BAUD	250000
#include <util/setbaud.h>							// Uart 0
#define	BAUD1	38400
#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>								// Tryby upienia
#include <avr/power.h>								// Wyaczanie peryferii



//---------------------------------------------------------------------------------------
/*
// Interrupt Vectors
// Interrupt Vector 0 is the reset vector.
#define INT0_vect         _VECTOR(1)   // External Interrupt Request 0
#define INT1_vect         _VECTOR(2)   // External Interrupt Request 1
#define PCINT0_vect       _VECTOR(3)   // Pin Change Interrupt Request 0
#define PCINT1_vect       _VECTOR(4)   // Pin Change Interrupt Request 0
#define PCINT2_vect       _VECTOR(5)   // Pin Change Interrupt Request 1
#define WDT_vect          _VECTOR(6)   // Watchdog Time-out Interrupt
#define TIMER2_COMPA_vect _VECTOR(7)   // Timer/Counter2 Compare Match A
#define TIMER2_COMPB_vect _VECTOR(8)   // Timer/Counter2 Compare Match A
#define TIMER2_OVF_vect   _VECTOR(9)   // Timer/Counter2 Overflow
#define TIMER1_CAPT_vect  _VECTOR(10)  // Timer/Counter1 Capture Event
#define TIMER1_COMPA_vect _VECTOR(11)  // Timer/Counter1 Compare Match A
#define TIMER1_COMPB_vect _VECTOR(12)  // Timer/Counter1 Compare Match B 
#define TIMER1_OVF_vect   _VECTOR(13)  // Timer/Counter1 Overflow
#define TIMER0_COMPA_vect _VECTOR(14)  // TimerCounter0 Compare Match A
#define TIMER0_COMPB_vect _VECTOR(15)  // TimerCounter0 Compare Match B
#define TIMER0_OVF_vect   _VECTOR(16)  // Timer/Couner0 Overflow
#define SPI_STC_vect      _VECTOR(17)  // SPI Serial Transfer Complete
#define USART_RX_vect     _VECTOR(18)  // USART Rx Complete
#define USART_UDRE_vect   _VECTOR(19)  // USART, Data Register Empty
#define USART_TX_vect     _VECTOR(20)  // USART Tx Complete
#define ADC_vect          _VECTOR(21)  // ADC Conversion Complete
#define EE_READY_vect     _VECTOR(22)  // EEPROM Ready
#define ANALOG_COMP_vect  _VECTOR(23)  // Analog Comparator
#define TWI_vect          _VECTOR(24)  // Two-wire Serial Interface
#define SPM_READY_vect    _VECTOR(25)  // Store Program Memory Read

void* tim_handler;
ISR(TIMER2_COMP_vect,ISR_NAKED)
{
asm("ijmp"::"z"(tim_handler));
}

Skoro "program gwny" nic nie robi to przerwanie nigdy nie moe zepsu jego stanu, a wic nie ma powodu eby obsuga przerwan zapisywaa rejestry czy cokolwiek - dlatego ISR_NAKED.


*/



#define	ddrLedDmx()	DDRF  |=  (1<<PF3) 
#define	OnLedDmx()	PORTF &= ~(1<<PF3)
#define	OffLedDmx()	PORTF |=  (1<<PF3)
#define	EorLedDmx()	PORTF ^=  (1<<PF3)

#define	ddrLedSt()	DDRF  |=  (1<<PF2) 
#define	OnLedSt()	PORTF &= ~(1<<PF2)
#define	OffLedSt()	PORTF |=  (1<<PF2)
#define	EorLedSt()	PORTF ^=  (1<<PF2)


void InitTimer0();


#define	OVERTIME_DMX	1 * 100		// Liczba sekund do trybu ofline w 10ms
word volatile TimerDmx0, TimerOfline;


#define	MIN_DMX_OFLINE	1			// Czas braku transmisji w sekundach, uznany jako brak sygnalu DMX
enum{DMX_OFFLINE, DMX_BREAK};


#define	LENBUFDMX	513
void InitUart0();
byte RxBuf0[ LENBUFDMX ];
byte volatile DmxStatus0 = DMX_OFFLINE;
word volatile LenDmx0, PtrTxRs;
byte FL_Skan = TRUE;


#define	LENBUFCMD	16
void InitUart1();
char RxBuf1[ LENBUFCMD ];
byte volatile FL_CmdComplit;
void SendUsart1( byte dana );


void PrintStopka();
void PrintCRLF();
void PrintOK();
void PrintString(char* text);
void PrintString_P(char* text);
#define	STR		":"	
#define	STRu	':'


//**********************************************************************//
//						Bity konfiguracyjne		 						//
//**********************************************************************//

__fuse_t __fuse __attribute__((section (".fuse"))) =
#if defined(__AVR_ATmega128__)
{
	.extended	= 0xFE,
	.high		= 0x99,
	.low		= 0x3F,
};
#else
	#error "NIEZNANY TYP PROCESORA w ustawieniu bitow konfiguracyjnych"
#endif


/*
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
*/



//**********************************************************************//
//						Program glowny			 						//
//**********************************************************************//
int main()
{
word x;
word crc;


	ddrLedSt(); ddrLedDmx();
	OnLedSt(); OffLedDmx();

	InitTimer0();

	InitUart0();
	InitUart1();


	//--- init WDG ---
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	wdt_enable( WDTO_500MS );									// Blokuje IRQ !!!


	sei();


/*
Parametry transmisji:	38400 8n1
Komendy wysyane:
ramka zkada si ze znaku startu ":", komenty i znaku koca ramki CRLF
	RST			- nastpi restart urzdzenia
	t			- nazwa urzdzenia
	v			- wersja urzdzenia
	e			- zatrzymanie skanowania
	s			- start skanowania
Dane odbierane:
	START		- pocztek bufora danych dmx
	STOP		- koniec bufora DMX
	IDLE		- brak komunikacji po DMX
	WAIT		- skanowanie zatrzymane przez uytkownika komend "e"
*/


	PrintString_P( PSTR( STR"RST"CRLF ) );						// Info o restarcie


	PrintStopka();



	//-----------------------------------------------------------------------------------
	//								Petla glowna
	//-----------------------------------------------------------------------------------
	while( 1 )
		{
		wdt_reset();


		if ( FL_CmdComplit )					// Jeli jest komenda
			{
			FL_CmdComplit = FALSE;				// Kasuj flage
			//----- interpretacja komendy -----//
			switch( RxBuf1[ 0 ] )
				{
				case( 'v' ):					// Wersja softu
					PrintString_P( PSTR( STR""VERSJA""CRLF ) );
					break;
				case( 't' ):					// Typ urzadzenia
					PrintString_P( PSTR( STR""TYPE""CRLF""CRLF ) );
					PrintStopka();
					break;
				case( 's' ):					// Start skanowania
					FL_Skan = TRUE;
					PrintOK();
					break;
				case( 'e' ):					// Stop skanowania
					FL_Skan = FALSE;					
					PrintOK();
					break;
				default:
					PrintString_P( PSTR( STR"ERR"CRLF ) );
				}
			}



		if ( DmxStatus0 != DMX_OFFLINE )		// Jest komunikacja
			{
			OffLedSt();
			if ( FL_Skan )						// i pozwolenie na skanowanie
				{
				PrintString_P( PSTR( STR"START"CRLF ) );
				SendUsart1(LenDmx0 >> 8);		// Dugo starszy bajt
				SendUsart1(LenDmx0 & 0xFF);		// Modszy bajt
				crc = (LenDmx0 >> 8) + (LenDmx0 & 0xFF); 
				for (x=0; x<LenDmx0; x++)
					{
					SendUsart1( RxBuf0[ x ] );
					crc += RxBuf0[ x ];
					}
				SendUsart1(crc >> 8);			// CRC starszy bajt
				SendUsart1(crc & 0xFF);			// Modszy bajt
				PrintString_P( PSTR( STR"STOP"CRLF ) );
				}
			else								// Jeli skanowanie zatrzymane przez uzytkownika
				{
				if ( !TimerOfline )				// jeli min czas
					{
					TimerOfline = 100;			// Czstotliwo wysyania IDLE
					PrintString_P( PSTR( STR"WAIT"CRLF ) );
					}
				}
			}
		else									// Brak komunikacji
			{
			if ( !TimerOfline )					// jeli min czas
				{
				TimerOfline = 100;				// Czstotliwo wysyania IDLE
				PrintString_P( PSTR( STR"IDLE"CRLF ) );
				}
			}
		}
}




//**********************************************************************//


void PrintStopka()
{
	PrintString_P( PSTR( TYPE" v"VERSJA""CRLF ) );				// Stopka
	PrintString_P( PSTR( "(C) 2014 AVT"CRLF ) );
	PrintString_P( PSTR( "Autch: Slawomir Skrzynski & Zygmunt Dziewonski"CRLF ) );
	PrintString_P( PSTR( "Compiled: "__DATE__" "__TIME__""CRLF ) );
}


//-------------------------------------------------------------------------
void PrintCRLF()
{
	SendUsart1( CR );
	SendUsart1( LF );
}


//-------------------------------------------------------------------------
void PrintOK()
{
	PrintString_P( PSTR( STR"OK"CRLF ) );
}


//-------------------------------------------------------------------------
void PrintString(char* string)
{
	while( *string )
		{
		SendUsart1( *string++ );
		}
}


//-------------------------------------------------------------------------
void PrintString_P(char* string)
{
	while( pgm_read_byte( string ) )
		{
		SendUsart1( pgm_read_byte( string++ ) );
		}
}


//-------------------------------------------------------------------------
//					Init timer 0
//-------------------------------------------------------------------------
void InitTimer0()
{
	TCCR0 = 7;							// podzielnik 1024
	TIMSK |= (1<<TOIE0);				// Zezwolenie na IRQ od przepelnienia timera
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0 - czasy MAB
//----------------------------------------------------------------------//
INTERRUPT( TIMER0_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
//byte dzielLedDmx=2;


	TCNT0 = 256 - 157;					// Przerwania co okoo 10ms


	if ( TimerDmx0 ) TimerDmx0--;
	if ( TimerOfline ) TimerOfline--;


	if ( TimerDmx0 == 1) { DmxStatus0 = DMX_OFFLINE; LenDmx0 = 0; OnLedSt(); OffLedDmx(); }


//	if ( (--dzielLedDmx)==0 )
//		{
//		dzielLedDmx = 50;
//		EorLedDmx();
//		}
}



//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart0()
{
	UBRR0H = 0;
	UBRR0L = 3;			// Dla 16MHz

	UCSR0A = 0;
	UCSR0B = (1<<RXEN0) | (1<<RXCIE0) | (1<<TXCIE0);	
	UCSR0C = (1<<USBS0) | (3<<UCSZ00);								// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART0_RX_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
word static CntDanych, curLenDmx, prevLenDmx;


	UsartStatus = UCSR0A;
	UsartDana = UDR0;
	UCSR0A = 0;


	if ( (UsartStatus & (1<<FE0)) )			// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{				
		TimerDmx0 = OVERTIME_DMX;
		DmxStatus0 = DMX_BREAK;				// Ustaw status
		prevLenDmx = curLenDmx;				// Zapamietaj poprzedni dugo
		curLenDmx = CntDanych;  			// Zapamitaj aktualn
		CntDanych = 0;						// Zeruj licznik danych
		if ( prevLenDmx==curLenDmx ) LenDmx0 = curLenDmx;	// Zapamitaj dugo danych gdy dwa wyniki takie same
		}
	else if(DmxStatus0 == DMX_BREAK)		// Jesli byl BREAK a pojawila sie nowa dana:
		{							
		if ( CntDanych==0 ) { EorLedDmx(); }// Sygna SC
		if ( CntDanych < LENBUFDMX ) RxBuf0[ CntDanych++ ] = UsartDana;	// nastepny kanal
		}
}



//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart1()
{
	UBRR1H = UBRRH_VALUE1;
	UBRR1L = UBRRL_VALUE1;

	UCSR1A = 0;
	UCSR1B = (1<<RXEN1) | (1<<TXEN1) | (1<<RXCIE1);	
	UCSR1C = (1<<USBS1) | (3<<UCSZ10);								// Set frame format: 8data, 2stop bit
}



//------------------------------------------------------------------------------
void SendUsart1( byte data )
{
	while ( !( UCSR1A & (1<<UDRE1)) ) ;
	UDR1 = data;
}



//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART1_RX_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
word static CntDanych;


	UsartStatus = UCSR1A;
	UsartDana = UDR1;
	UCSR1A = 0;

	if ( UsartDana == STRu )				// Znak statu ?
		{
		CntDanych = 0;
		}
	else if ( UsartDana == CR )				// Znak stopu ?
		{
		FL_CmdComplit = 1;					// Flaga odbioru
		RxBuf1[ CntDanych++ ] = 0;			// Znak koca tekstu
		}
	else if ( CntDanych < LENBUFCMD )
		{
		RxBuf1[ CntDanych++ ] = UsartDana;
		}
}


//------------------------------------------------------------------------------

